#define DEMO_OBJS

#include "amber.hpp"
#include "demo.hpp"
#include "shapes.hpp"

#define X 0
#define Y 1
#define Z 2

void init(channelClass *ch)
{
	V3 pos = {0.0,0.0,0.0}, p1, p2, p3, p4;
	V3 dir = {0.0,1.0,1.0}, ext, ext2, scl;
	F3 lpos = {0.0,10.0,0.0};
	F3 ldir = {0.0,-1.0,0.0}, vpPos;
	F4 bgcol = {0.2,0.2,0.6,0.0};
	F4 col = {0.0, 0.5, 0.7, 0.8};
	universeClass *univ = amber->getCurrentUniverse();
	geometryClass *d, *bb;
	circleClass *circle;
	vertexClass *v;

	univ->light0->setDirection(ldir);
	univ->light0->setPosition(lpos);
	ch->setPosition(pos);
	bb = new geometryClass("birdBath.wrl");
	bb->scale(0.01);
	bb->rotate(X, Pi);
	bb->getExtents(ext);
	pos[Y] -= 0.7*(ext[Y]/2.0);
	bb->setPosition(pos);

	V3_init(vpPos);
	vpPos[Z] = -1.25 * ext[X];
	vpPos[Y] = 2.0 * ext[Y];
	ch->rotate(X, Pi/6.0);
	ch->setPosition(vpPos);

	d  = new geometryClass("duck.wrl");

	circle = new circleClass((ext[X]/2.0)*0.90, 15);
	w = new waterClass(circle, 5.0, 0.01, 0.04, 3.0);
	w->geo->setAllColor(col);
	V3_init(pos);
	w->geo->setPosition(pos);
	bb->getExtents(ext);
	d->getExtents(ext2);
	d->scale((1.0/(ext2[Z]/ext[Z])) * 0.1);
	V3_init(pos);
	d->setPosition(pos);
	d->rotate(Y, Pi);
	v = w->geo->getVertex(0);
	d->setData((void *)v);
	w->geoList->append((void *)d);

	ch->setPolyRenderAs(_TRIS);
}

void cleanup()
{
	delete w;
}

void processChar(unsigned int nChar)
{
	switch(nChar) {
		case 'D':
		case 'd':
			V3 pos,ext;
			universeClass *univ = amber->getCurrentUniverse();
			V3_init(pos);
			univ->getExtents(ext);
			pos[X] = (double)(rand() % (int)ext[X]) - (int)ext[X]/2;
			pos[Z] = (double)(rand() % (int)ext[Z]) - (int)ext[Z]/2;
			w->drop(pos, 0.5);
			break;
	}
}

