#define DEMO_OBJS

#include <windows.h>
#include "amber.hpp"
#include "demo.hpp"

#define X 0
#define Y 1
#define Z 2

void init(channelClass *ch)
{
	polygonClass *p;
	geometryClass *g = new geometryClass();
	vertexClass *v;
	universeClass *univ = amber->getCurrentUniverse();
	V3 pos = {0.0, 0.0, 10.0};

	p = new polygonClass();

	v = new vertexClass(-0.5, -0.5, 0.0);
	p->addVertex(v);
	g->addVertex(v);
	v = new vertexClass( 0.5, -0.5, 0.0);
	p->addVertex(v);
	g->addVertex(v);
	v = new vertexClass( 0.5,  0.5, 0.0);
	p->addVertex(v);
	g->addVertex(v);
	v = new vertexClass(-0.5,  0.5, 0.0);
	p->addVertex(v);
	g->addVertex(v);

	g->addPolygon(p);
	g->complete();
	g->addTo(univ);

	fire = new fireClass();
	fire->addPoly(p);

	ch->setPosition(pos);

}

void cleanup()
{
	delete fire;
}

void processChar(unsigned int nChar)
{
	switch(nChar) {
		case 'J':
			fire->wind=-1;
			break;
		case 'K':
			fire->wind=1;
			break;
		case 'I':
			fire->wind=0;
			break;
		case '1':
			fire->flare=0;
			break;
		case '2':
			fire->flare=1;
			break;
		case '3':
			fire->flare=2;
			break;
		case 'N':
			if(fire->water>0)
				fire->water-=1;
			break;
		case 'M':
			if(fire->water<16)
				fire->water+=1;
			break;
	}
}

