// framevw.cpp : implementation of the CFramedView class
//

#include "stdafx.h"
#include "framed.h"

#include "framedoc.h"
#include "framevw.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFramedView

IMPLEMENT_DYNCREATE(CFramedView, CView)

BEGIN_MESSAGE_MAP(CFramedView, CView)
	//{{AFX_MSG_MAP(CFramedView)
	ON_WM_SIZE()
	ON_COMMAND(ID_BACKGROUND, OnBackground)
	ON_COMMAND(ID_BOUNDINGBOX, OnBoundingbox)
	ON_UPDATE_COMMAND_UI(ID_BOUNDINGBOX, OnUpdateBoundingbox)
	ON_COMMAND(ID_MATERIALS, OnMaterials)
	ON_UPDATE_COMMAND_UI(ID_MATERIALS, OnUpdateMaterials)
	ON_COMMAND(ID_MOUSE, OnMouse)
	ON_UPDATE_COMMAND_UI(ID_MOUSE, OnUpdateMouse)
	ON_COMMAND(ID_NORMALS, OnNormals)
	ON_UPDATE_COMMAND_UI(ID_NORMALS, OnUpdateNormals)
	ON_COMMAND(ID_PLATTER, OnPlatter)
	ON_UPDATE_COMMAND_UI(ID_PLATTER, OnUpdatePlatter)
	ON_COMMAND(ID_POINTS, OnPoints)
	ON_UPDATE_COMMAND_UI(ID_POINTS, OnUpdatePoints)
	ON_COMMAND(ID_POLYGONS, OnPolygons)
	ON_UPDATE_COMMAND_UI(ID_POLYGONS, OnUpdatePolygons)
	ON_COMMAND(ID_SHADING, OnShading)
	ON_UPDATE_COMMAND_UI(ID_SHADING, OnUpdateShading)
	ON_COMMAND(ID_TRIANGLES, OnTriangles)
	ON_UPDATE_COMMAND_UI(ID_TRIANGLES, OnUpdateTriangles)
	ON_COMMAND(ID_WIREFRAME, OnWireframe)
	ON_UPDATE_COMMAND_UI(ID_WIREFRAME, OnUpdateWireframe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFramedView construction/destruction

CFramedView::CFramedView()
{
	// TODO: add construction code here
	ch=NULL;
	mouse=NULL;
	platter=NULL;
	useMouse=1;
}

CFramedView::~CFramedView()
{
	delete mouse;
	delete platter;
	delete ch;
}

/////////////////////////////////////////////////////////////////////////////
// CFramedView drawing

void CFramedView::OnDraw(CDC* pDC)
{
	CFramedDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CFramedView diagnostics

#ifdef _DEBUG
void CFramedView::AssertValid() const
{
	CView::AssertValid();
}

void CFramedView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFramedDoc* CFramedView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFramedDoc)));
	return (CFramedDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFramedView message handlers

void CFramedView::OnInitialUpdate() 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CView::OnInitialUpdate();

	if (!ch) {
		ch = new channelClass(m_hWnd);
		mouse = new mouseClass(m_hWnd);
		platter = new platterClass(m_hWnd);
		mouse->attachChannel(ch);
	}
}

BOOL CFramedView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.style |= WS_CLIPCHILDREN | WS_CLIPSIBLINGS;
	return CView::PreCreateWindow(cs);
}

void CFramedView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if (!ch || !IsWindowVisible()) return;
	ch->resetPerspective();
}

void CFramedView::OnBackground() 
{
	// TODO: Add your command handler code here
	F4 color;
	COLORREF cr;
	CColorDialog dlg;

	ch->getBackgroundColor(color);
	
	dlg.m_cc.Flags |= CC_RGBINIT;
	dlg.m_cc.rgbResult = RGB( (int)(color[0]*255.0), 
	                          (int)(color[1]*255.0), 
	                          (int)(color[2]*255.0));

	if (!dlg.DoModal()) return;

	cr = dlg.GetColor();
	V4_init(color);
	color[0] = (float)GetRValue(dlg.m_cc.rgbResult)/255.0;
	color[1] = (float)GetGValue(dlg.m_cc.rgbResult)/255.0;
	color[2] = (float)GetBValue(dlg.m_cc.rgbResult)/255.0;
	ch->setBackgroundColor(color);
	
}

void CFramedView::OnBoundingbox() 
{
	// TODO: Add your command handler code here
	if (ch->getState() & RENDER_BOUNDINGBOX) {
		ch->disableState(RENDER_BOUNDINGBOX);
	}
	else {
		ch->enableState(RENDER_BOUNDINGBOX);
	}
	
}

void CFramedView::OnUpdateBoundingbox(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getState() & RENDER_BOUNDINGBOX);	
	
}

void CFramedView::OnMaterials() 
{
	// TODO: Add your command handler code here
	if (ch->getState() & RENDER_MATERIAL) {
		ch->disableState(RENDER_MATERIAL);
	}
	else {
		ch->enableState(RENDER_MATERIAL);
	}
	
}

void CFramedView::OnUpdateMaterials(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getState() & RENDER_MATERIAL);	
	
}

void CFramedView::OnMouse() 
{
	// TODO: Add your command handler code here
	if (useMouse) return;
	useMouse=1;
	platter->removeChannel(ch);		
	mouse->attachChannel(ch);
	
}

void CFramedView::OnUpdateMouse(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(useMouse);	
	
}

void CFramedView::OnNormals() 
{
	// TODO: Add your command handler code here
	if (ch->getState() & RENDER_NORMAL) {
		ch->disableState(RENDER_NORMAL);
	}
	else {
		ch->enableState(RENDER_NORMAL);
	}
}

void CFramedView::OnUpdateNormals(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getState() & RENDER_NORMAL);	
	
}

void CFramedView::OnPlatter() 
{
	// TODO: Add your command handler code here
	if (!useMouse) return;
	useMouse=0;
	mouse->removeChannel(ch);
	platter->attachChannel(ch);
	
}

void CFramedView::OnUpdatePlatter(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(!useMouse);	
	
}

void CFramedView::OnPoints() 
{
	// TODO: Add your command handler code here
	ch->setPolyRenderAs(_POINTS);
	
}

void CFramedView::OnUpdatePoints(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getPolyRenderAs() == _POINTS);	
	
}

void CFramedView::OnPolygons() 
{
	// TODO: Add your command handler code here
	ch->setPolyRenderAs(_POLYS);
	
}

void CFramedView::OnUpdatePolygons(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getPolyRenderAs() == _POLYS);	
	
}

void CFramedView::OnShading() 
{
	// TODO: Add your command handler code here
	if (ch->getPolyShading() == _SHADED) {
		ch->setPolyShading(_FLAT);
	}
	else {
		ch->setPolyShading(_SHADED);
	}
	
}

void CFramedView::OnUpdateShading(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getPolyShading() == _SHADED);	
	
}

void CFramedView::OnTriangles() 
{
	// TODO: Add your command handler code here
	ch->setPolyRenderAs(_TRIS);
	
}

void CFramedView::OnUpdateTriangles(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getPolyRenderAs() == _TRIS);	
	
}

void CFramedView::OnWireframe() 
{
	// TODO: Add your command handler code here
	if (ch->getPolyFill() == _NOFILL) {
		ch->setPolyFill(_FILL);
	}
	else {
		ch->setPolyFill(_NOFILL);
	}
	
}

void CFramedView::OnUpdateWireframe(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(ch->getPolyFill() == _NOFILL);	
	
}
