// framevw.h : interface of the CFramedView class
//
/////////////////////////////////////////////////////////////////////////////
#include "channel.hpp"
#include "mouse.hpp"
#include "platter.hpp"

class CFramedView : public CView
{
protected: // create from serialization only
	CFramedView();
	DECLARE_DYNCREATE(CFramedView)

// Attributes
public:
	CFramedDoc* GetDocument();
	channelClass *ch;
	mouseClass *mouse;
	platterClass *platter;
	flagType useMouse;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFramedView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFramedView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CFramedView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBackground();
	afx_msg void OnBoundingbox();
	afx_msg void OnUpdateBoundingbox(CCmdUI* pCmdUI);
	afx_msg void OnMaterials();
	afx_msg void OnUpdateMaterials(CCmdUI* pCmdUI);
	afx_msg void OnMouse();
	afx_msg void OnUpdateMouse(CCmdUI* pCmdUI);
	afx_msg void OnNormals();
	afx_msg void OnUpdateNormals(CCmdUI* pCmdUI);
	afx_msg void OnPlatter();
	afx_msg void OnUpdatePlatter(CCmdUI* pCmdUI);
	afx_msg void OnPoints();
	afx_msg void OnUpdatePoints(CCmdUI* pCmdUI);
	afx_msg void OnPolygons();
	afx_msg void OnUpdatePolygons(CCmdUI* pCmdUI);
	afx_msg void OnShading();
	afx_msg void OnUpdateShading(CCmdUI* pCmdUI);
	afx_msg void OnTriangles();
	afx_msg void OnUpdateTriangles(CCmdUI* pCmdUI);
	afx_msg void OnWireframe();
	afx_msg void OnUpdateWireframe(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in framevw.cpp
inline CFramedDoc* CFramedView::GetDocument()
   { return (CFramedDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
