////////////////////////////////////////////////////////////////////////
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995 - 1996
//**********************************************************************
//  NOTICE: THIS [PROGRAM, DATABASE, DOCUMENT].CONSISTS OF TRADE SECRETS
//  THAT ARE THE PROPERTY OF DIVE LABORATORIES, INC. THE CONTENTS MAY NOT
//  BE USED OR DISCLOSED WITHOUT EXPRESS WRITTEN PERMISSION OF THE OWNER.
//**********************************************************************
//  FILE:   intxmsg.hpp
//
//  DESCRIPTION
//		intersection message passing class
//
//  Author: B. Green
//
//  Modification History:
//  ?/??/95 Created
//	8/03/95 SGI/stand-alone port
//	01/20/96 geometryClass and polygonClass pointers added.
//
////////////////////////////////////////////////////////////////////////

#ifndef _INTXMSG_HPP
#define _INTXMSG_HPP

class intxMsgClass;

#include"vrtypes.hpp"
class geometryClass;
class polygonClass;

#ifndef _DEFAULT
  #define DEFAULT -1
#endif

////////////////////////////////////////////////////////////////////////

class intxMsgClass {

	private:
	public:

		polygonClass *iPoly;
		geometryClass *iGeo;
	

		int objID,
			polyID;

		V3 iPos;

		void getIntx(V3 pos, int& objectID, int& polyID);
		void getIntxLocalPos(V3 pos);
		void getIntxWorldPos(V3 pos);
		int  getIntxObject();
		int  getIntxPoly();

		void setIntx(V3 pos,int object,int polyID=0);
		void set( V3 pos, geometryClass *geo, polygonClass *poly );

		intxMsgClass();
		intxMsgClass(V3 pos,int objectID=DEFAULT,int polyID=DEFAULT);
		intxMsgClass(V3 pos, geometryClass *geo, polygonClass *poly );
		~intxMsgClass();
};


//**********************************************************************
//  NOTICE: THIS [PROGRAM, DATABASE, DOCUMENT].CONSISTS OF TRADE SECRETS
//  THAT ARE THE PROPERTY OF DIVE LABORATORIES, INC. THE CONTENTS MAY NOT
//  BE USED OR DISCLOSED WITHOUT EXPRESS WRITTEN PERMISSION OF THE OWNER.
//**********************************************************************
#endif
