//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//  FILE:   JOYSTICK.HPP
//
//  DESCRIPTION
//  This file provides the function prototypes for the joystickClass
//  that is the driver for the standard window joystick.
//
//  Author: M. Doucet
//
//  Modification History:
//  7/3/95	Created
//
//**********************************************************************
#ifndef _JOYSTICK_HPP
#define _JOYSTICK_HPP

#include <windows.h>
#include "sensor.hpp"
#include "style.hpp"

class joystickClass : public sensorClass, public styleClass {

private:

	V3  mRotations;
	V3  mDeltas;
	V3  jmins, jmaxs, ranges, halfs, mids, posBias, negBias;
	void *hostWnd;
	int driverOk, nButtons;
	unsigned int joyId;

public:

	// Current joystick position +-1.0
	V3 pos;
	unsigned int buttonMask;

	// Button down flags
	int button[10];

	void style(void);

	void mouseEvent(mouseEventEnum event, I2 point, void *wnd);

	joystickClass(unsigned int joystickID = JOYSTICKID1,
	              sensorAngleEnumType    sa = NO_ANGLES,
		          sensorPositionEnumType sp = ABSOLUTE_POSITIONS);


	~joystickClass();

};

#endif
