//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//  FILE:   MATRIX.HPP
//
//  DESCRIPTION
//  This file provides the function prototypes for the matrixClass
//
//  Author: M. Doucet
//
//  Modification History:
//  6/13/95	Created
//
//**********************************************************************
#ifndef _MATRIX_HPP
#define _MATRIX_HPP

#include "quat.hpp"
#include "vrtypes.hpp"

class matrixClass {

public:

	M16 m;

	void identity();
	void set(M16 vals);

	void rotate(float angle, float axisX, float axisY, float axisZ);
	void translate(float transX, float transY, float transZ);
	void zeroTranslate();
	void scale(float scaleX, float scaleY, float scaleZ);
	void setOrientation(quatClass q);
	void transpose();

	void applyTo(V3 pos);

	// Equivalent euler x,y,z rotations
	void getEuler(V3 eulerAngle);

	void operator=(matrixClass *mat);
		
	matrixClass();
	~matrixClass();
};

#endif
