//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//  FILE:   MOUSE.HPP
//
//  DESCRIPTION
//  This file provides the function prototypes for the mouseClass
//  that is the driver for the standard window mouse.
//
//  Author: M. Doucet
//
//  Modification History:
//  7/3/95	Created
//
//**********************************************************************
#ifndef _MOUSE_HPP
#define _MOUSE_HPP


#include "sensor.hpp"
#include "style.hpp"

class mouseClass : public sensorClass, public styleClass {

private:

	V3  mRotations;
	V3  mDeltas;
	void *hostWnd;

public:

	// Current mouse screen position +-1.0
	D2 pos;

	// Button down flags
	int rightBD, leftBD, middleBD;

	void style(void);
#ifdef WIN32
	void mouseEvent(mouseEventEnum event, I2 point, void *wnd);
#endif
	void mouseMove(float width, float height, float mouseX, float mouseY);
	void leftButtonDown(float width, float height, float mouseX, float mouseY);
	void rightButtonDown(float width, float height, float mouseX, float mouseY);
	void leftButtonUp();
	void rightButtonUp();

	mouseClass(void *wnd,
              sensorAngleEnumType    sa = DELTA_ANGLES,
				  sensorPositionEnumType sp = DELTA_POSITIONS);

	~mouseClass();

};

#endif
