//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//  FILE:   POINT.HPP
//
//  DESCRIPTION
//  This file provides the function prototypes for the 
//  pointClass
//
//  Author: M. Doucet
//
//  Modification History:
//  6/13/95	Created
//
//**********************************************************************
#ifndef _POINT_HPP
#define _POINT_HPP

#include "vrtypes.hpp"
#include "vertex.hpp"

#ifndef AMBERRT
#include "texture.hpp"
#include "material.hpp"
#endif

class geometryClass;
class geometryPrivateClass;
class renderStateClass;

class pointClass {

	friend class geometryClass;
	friend class geometryPrivateClass;
	friend class renderStateClass;

private:

	geometryClass *parent;

#ifndef AMBERRT
	materialClass *mat;
#endif

public:

	vertexClass 		*vertex;

	F4 			 color;
	void			 setColor(F4 col);

	// Material Functions
	void setMaterial(materialClass *mat);
	void setMaterial(char *name);
	materialClass *getMaterial();

	// Vertex functions
	//
	void         setVertex(vertexClass *v);
	vertexClass *getVertex();
	void         getVertexPos(V3 pos);

	pointClass(vertexClass *v=NULL);
	~pointClass();
};

#endif
