//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//
//  FILE:   SIM.HPP
//
//  DESCRIPTION
//  This header provides the class definition for the 
//  simClass class.
//
//**********************************************************************
#ifndef SIMULATE
#define SIMULATE

#include "style.hpp"
#include "law.hpp"

//---------------------------------------------------------------------
//  This is the class definition for the simClass.
//
class simClass {

//  Private Data

private:

    int actionEx, styleEx, lawEx, doSimulate;

	 float lastTime;

public:
    
//  Action & Style lists and the associated operations

    void executeStyles();

    void executeActions();

    void executeLaws();

	 void setDoSimulate(int flag);

	 int getDoSimulate();

//  Protected Data

//  Public Data

    int cycle;

	 float simTime;

    int simFlag;

//  action, style, and law execution control

    void setStyleEx(int flag);

    int getStyleEx();

    void setActionEx(int flag);

    int getActionEx();

    void setLawEx(int flag);

    int getLawEx();

//  Simulation Management

    void simulate();

//  Constructor Functions

    simClass(float tC = 0.1);
   
//  Destructor Function

    ~simClass();
    
};

#endif
