//**********************************************************************
//  DIVE Laboratories, Inc.
//  Copyright(c) 1995
//  All rights reserved.
//  FILE:   VIOTRK.HPP
//
//  DESCRIPTION
//  This file provides the function prototypes for the vioTrkClass
//  that is the driver for the Virtual I/O tracker.
//
//  Author: M. Doucet
//
//  Modification History:
//  7/3/95	Created
//
//**********************************************************************
#ifndef _VIOTRK_HPP
#define _VIOTRK_HPP

#include "sensor.hpp"
#include "style.hpp"

class vioTrkClass : public sensorClass, public styleClass {

private:

	V3 angle;

public:

	void style(void);

	void init();

	int  isActive();

	void mouseEvent(mouseEventEnum event, I2 point, void *wnd);

	vioTrkClass(portEnumType 			  port=COM1,
	            int          			  baud=19200,
	            sensorAngleEnumType    sa = ABSOLUTE_ANGLES,
					sensorPositionEnumType sp = NO_POSITIONS);

	~vioTrkClass();

};

#endif
